#!/bin/echo It can be only inclusion. Incorrect start

# Use this for include.
# [ -z "${_NSG_DIALOG}" ] && { . /usr/local/share/nsg/lib/dialog.sh || do_it_if_error; }

_NSG_DIALOG=1

[ -z "${_NSG_FUNCTIONS}" ] && { . /usr/local/share/nsg/lib/functions.sh || return; }

nsg_wait_getkey() {
    l_usage() {
	echo "$0: function usage: nsg_wait_getkey [-t timeout] [-d default_choice] var... "
    }

    l_restore_tty() {
	[ -n "${l_old_tty_settings}" ] && stty "${l_old_tty_settings}"
    }

    l_return_hook() {
	l_restore_tty
    }

    local l_i l_c l_s l_name l_old_tty_settings
    local l_timeout l_defchoice

    l_timeout="5"
    l_defchoice=""

    while getopts t:d: l_name; do
	case "${l_name}" in
	    (t) 
	    l_timeout="$OPTARG"
	    if isdigit "${l_timeout}"; then
		:
	    else
		echo "$0: '${l_timeout}': timeout argument contains not a digit (0 through 9) character"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    if [ "${l_timeout}" -lt "0" -o "${l_timeout}" -gt "25" ]; then
		echo "$0: '${l_timeout}': incorrect timeout argument ( 0 <= timeout <= 25 )"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (d) 
	    l_defchoice="$OPTARG"
	    if isprint "${l_defchoice}"; then
		:
	    else
		echo "$0: '${l_defchoice}': default_choice argument contains not a printable character including space"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (?) 
	    l_usage
	    l_return_hook
	    return ${EX_USAGE}
	    ;;
	esac
    done
    shift $(($OPTIND - 1)); OPTIND="1"

    if [ "$#" -le "0" ]; then 
	echo "$0: '$@': incorrect quantity of operands"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi
   
    if isidentifier "$@"; then
	:
    else
	echo "$0: '$@': var not a valid identifier"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi

    # save tty
    l_old_tty_settings="$(stty -g)"

    # flush stdin 
    stty -icanon min 0 time 0 -echo
    while [ -n "$(dd bs=64 count=1 2> /dev/null)" ]; do
	continue
    done

    #get key
    l_restore_tty
    stty -icanon min 0 time ${l_timeout}0 -echo
    for l_i in "$@"; do
	eval "${l_i}"=""
	l_c=""
	l_s=""
	while true; do
	    l_c="$(dd bs=1 count=1 2> /dev/null | hexdump -e '"%_c"')"
	    
	    if [ -z "${l_c}" ]; then
		l_restore_tty
		stty -icanon min 0 time ${l_timeout}0 -echo
		break
	    else
		if [ "${l_c}" == "\\" ]; then
		    l_c="\\${l_c}"
		elif echo "${l_c}" | grep -q -e '^[0-3][0-7][0-7]$'; then
		    l_c="\\${l_c}"
		fi
		l_s="${l_s}${l_c}"
		echo -n "${l_c}"
		
		l_restore_tty
		stty -icanon min 0 time 0 -echo
	    fi
	done
	
	eval "${l_i}"='${l_s}'
	
	[ -z "${l_s}" ] && eval "${l_i}"='${l_defchoice}'
    done
    
    
    l_return_hook
}

nsg_wait_readkeys() {
    l_usage() {
	echo "$0: function usage: nsg_wait_readkeys [-t timeout] [-d default_choice] var..."
	
    }

    l_restore_tty() {
	[ -n "${l_old_tty_settings}" ] && stty "${l_old_tty_settings}"
    }

    l_return_hook() {
	l_restore_tty
    }

    local l_i l_c l_s l_name l_old_tty_settings
    local l_timeout l_defchoice

    l_timeout="5"
    l_defchoice=""

    while getopts t:d: l_name; do
	case "${l_name}" in
	    (t) 
	    l_timeout="$OPTARG"
	    if isdigit "${l_timeout}"; then
		:
	    else
		echo "$0: '${l_timeout}': timeout argumentcontains not a digit (0 through 9) character "
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    if [ "${l_timeout}" -lt "0" -o "${l_timeout}" -gt "25" ]; then
		echo "$0: '${l_timeout}': incorrect timeout argument ( 0 <= timeout <= 25 )"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (d) 
	    l_defchoice="$OPTARG"
	    if isprint "${l_defchoice}"; then
		:
	    else
		echo "$0: '${l_defchoice}': default_choice argument contains not a printable character including space"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (?) 
	    l_usage
	    l_return_hook
	    return ${EX_USAGE}
	    ;;
	esac
    done
    shift $(($OPTIND - 1)); OPTIND="1"

    if [ "$#" -le "0" ]; then
	echo "$0: '$@': incorrect quantity of operands"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi
   
    if isidentifier "$@"; then
	:
    else
	echo "$0: '$@': var not a valid identifier"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi

    # save tty
    l_old_tty_settings="$(stty -g)"

    # flush stdin 
    stty -icanon min 0 time 0 -echo
    while [ -n "$(dd bs=64 count=1 2> /dev/null)" ]; do
	continue
    done

    # read keys
    l_restore_tty
    stty -icanon min 0 time ${l_timeout}0 -echo
    l_c=""
    for l_i in "$@"; do
	eval "${l_i}"=""
	while true; do
	    l_s=""
	    while true; do
		l_c="$(dd bs=1 count=1 2> /dev/null | hexdump -e '"%_c"')"

		if [ -z "${l_c}" -o "${l_c}" == "\n" ]; then
		    l_s="${l_s}${l_c}"
		    echo -n "${l_c}"
		    
		    l_restore_tty
		    stty -icanon min 0 time ${l_timeout}0 -echo
		    break
		else
		    if [ "${l_c}" == "\\" ]; then
			l_c="\\${l_c}"
		    elif echo "${l_c}" | grep -q -e '^[0-3][0-7][0-7]$'; then
			l_c="\\${l_c}"
		    fi
		    l_s="${l_s}${l_c}"
		    echo -n "${l_c}"
		    
		    l_restore_tty
		    stty -icanon min 0 time 0 -echo
		fi
    	    done

	    eval eval "${l_i}"='\${${l_i}}\${l_s}'

 	    if [ "${l_c}" == "\n" ]; then
 		break
	    elif [ -z "${l_s}" ]; then
 		eval "${l_i}"='${l_defchoice}'
 		break
 	    fi
	done
    done
    
    l_return_hook
}

nsg_dialog_sure() {
    l_usage() {
	echo "$0: function usage: nsg_dialog_sure [-t timeout] [-d default_choice] var"
    }

    l_restore_tty() {
	[ -n "${l_old_tty_settings}" ] && stty "${l_old_tty_settings}"
    }

    l_return_hook() {
	l_restore_tty
    }

    local l_i l_name l_old_tty_settings
    local l_defchoice l_timeout

    l_timeout="5"
    l_defchoice="no"

    # save tty
    l_old_tty_settings="$(stty -g)"
    stty -echo
    
    while getopts t:d: l_name; do
	case $l_name in
	    (t)
	    l_timeout="$OPTARG"
	    ;;
	    (d)
	    l_defchoice="$OPTARG"
	    if echo "${l_defchoice}" | grep -qv -e '^yes$' -e '^no$'; then
		echo "$0: '${l_defchoice}': default_choice argument must one of 'yes' 'no'"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (?)
	    l_usage
	    l_return_hook
	    return ${EX_USAGE}
	    ;;
	esac
    done
    shift $(($OPTIND - 1)); OPTIND="1"

    if [ "$#" -ne "1" ]; then
	echo "$0: '$@': incorrect quantity of operands"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi

    echo ""
    echo "timeout='${l_timeout}', default_choice='${l_defchoice}'"
    echo -n "Are You sure? [yes/no]: "

    while nsg_wait_readkeys -t "${l_timeout}" -d "${l_defchoice}" -- "$@"; do
	echo ""
	if eval echo "\$$@" | grep -qv -e '^yes\(\\n\)\?$' -e '^no\(\\n\)\?$' -e '^\\n$'; then
	    echo -n "Try again: "
	    continue
	else
	    if [ "$(eval echo \"\$$@\")" == "\n" ]; then
		eval "$@"='${l_defchoice}'
	    else
		eval "$@"="$(eval echo "\$$@" | sed 's/^\(.*\)\\n$/\1/')"
	    fi
	    eval echo "\$$@"
	    l_return_hook
	    return ${EX_OK}
	fi
    done
    
    l_return_hook
    return ${EX_UNAVAILABLE}
}

nsg_dialog_yesno() {
    l_usage() {
	echo "$0: function usage: nsg_dialog_yesno [-t timeout] [-d default_choice] var"
    }

    l_restore_tty() {
	[ -n "${l_old_tty_settings}" ] && stty "${l_old_tty_settings}"
    }

    l_return_hook() {
	l_restore_tty
    }

    local l_i l_name l_old_tty_settings
    local l_defchoice l_timeout

    l_timeout="5"
    l_defchoice="no"

    # save tty
    l_old_tty_settings="$(stty -g)"
    stty -echo
    
    while getopts t:d: l_name; do
	case $l_name in
	    (t)
	    l_timeout="$OPTARG"
	    ;;
	    (d)
	    l_defchoice="$OPTARG"
	    if echo "${l_defchoice}" | grep -qv -e '^yes$' -e '^no$'; then
		echo "$0: '${l_defchoice}': default_choice argument must one of 'yes' 'no'"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (?)
	    l_usage
	    l_return_hook
	    return ${EX_USAGE}
	    ;;
	esac
    done
    shift $(($OPTIND - 1)); OPTIND="1"

    if [ "$#" -ne "1" ]; then
	echo "$0: '$@': incorrect quantity of operands"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi

    echo "timeout='${l_timeout}', default_choice='${l_defchoice}'"
    echo -n "[yes/no]: "

    while nsg_wait_readkeys -t "${l_timeout}" -d "${l_defchoice}" -- "$@"; do
	echo ""
	if eval echo "\$$@" | grep -qv -e '^yes\(\\n\)\?$' -e '^no\(\\n\)\?$' -e '^\\n$'; then
	    echo -n "Try again: "
	    continue
	else
	    if [ "$(eval echo \"\$$@\")" == "\n" ]; then
		eval "$@"='${l_defchoice}'
	    else
		eval "$@"="$(eval echo "\$$@" | sed 's/^\(.*\)\\n$/\1/')"
	    fi
	    eval echo "\$$@"
	    l_return_hook
	    return ${EX_OK}
	fi
    done
    
    l_return_hook
    return ${EX_UNAVAILABLE}
}
